de.caff.generics

## Class IntIndexable.Base

- java.lang.Object
- - de.caff.generics.IntCountable.Base
  - - de.caff.generics.IntIndexable.Base

- All Implemented Interfaces:
    IntCountable, IntIndexable, PrimitiveIntIterable, Sizeable, java.lang.Comparable<IntIndexable>, java.lang.Iterable<java.lang.Integer>
  Direct Known Subclasses:
    MutableIntIndexable.Base
  Enclosing interface:
    IntIndexable

      public abstract static class IntIndexable.Base
      extends IntCountable.Base
      implements IntIndexable, java.lang.Comparable<IntIndexable>

  Abstract base class which provides useful implementations for `Object.equals(Object)`, `Object.hashCode()`, `Object.toString()`. It also provides `Comparable.compareTo(Object)`.
  See Also:
    `IntIndexable.asBase()`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface de.caff.generics.IntIndexable

      `IntIndexable.Base, IntIndexable.EntryConsumer, IntIndexable.IntIndexableSpliterator`

  - ### Field Summary

    - ### Fields inherited from interface de.caff.generics.IntIndexable

      `EMPTY, SINGLE_0`

    - ### Fields inherited from interface de.caff.generics.PrimitiveIntIterable

      `EMPTY_INT_ITERATOR`

    - ### Fields inherited from interface de.caff.generics.Sizeable

      `NULL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Base()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IntIndexable.Base` | `asBase()` Convert this into a base countable.
    `int` | `compareTo(IntIndexable o)`
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface de.caff.generics.IntIndexable

      `addAllTo, addToArray, addToArray, asCollection, asIndexable, asList, asLongIndexable, asUnsignedIndexable, binarySearch, binarySearch, compare, compareUnsigned, emptyIndexable, equal, equal, firstMatch, foldLeft, forEachIntEntry, frozen, frozenIntSpliterator, get, getMod, gyt, hash, headSet, indexes, init, initByIndex, intIndexes, intIterator, intIterator, intSpliterator, isEmpty, isOrdered, isStrictlyOrdered, iterator, lastMatch, listIterator, nextMatch, ordered, ordered, previousMatch, range, range, rangeFromSize, reverse, rotated, singleton, subSet, sybSet, tailSet, toArray, toList, toString, view, viewArray, viewArray, viewArray, viewAsBoolean, viewAsByte, viewAsChar, viewAsDouble, viewAsDouble, viewAsFloat, viewAsLong, viewAsLong, viewAsShort, viewAsUnsignedLong, viewByIndex, viewIndexable, viewIndexable, viewIndexable, viewList, viewList, viewList, viewNumberArray, viewOp, with, withAppendedValue, withCachedHash, withExchangedValueAt, withInsertedValueAt, withRemovedValueAt, withSwappedValuesAt, wyth`

    - ### Methods inherited from interface de.caff.generics.IntCountable

      `empty, filtered, first, isEqual, isSorted, isStrictlySorted, last, sorted, toString, uniform, viewCollection, viewCollection, viewCollectionN, viewCollectionN`

    - ### Methods inherited from interface de.caff.generics.PrimitiveIntIterable

      `average, containsInt, forEachInt, forEachIntFragile, longSum, longSumX, spliterator, stream, sum, sumX`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

    - ### Methods inherited from interface de.caff.generics.Sizeable

      `size`

- - ### Constructor Detail

    - #### Base

          public Base()

  - ### Method Detail

    - #### compareTo

          public int compareTo(@NotNull
                               IntIndexable o)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<IntIndexable>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `IntCountable.Base`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `IntCountable.Base`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `IntCountable.Base`

    - #### asBase

          @NotNull
          public IntIndexable.Base asBase()

      Description copied from interface: `IntCountable`
      Convert this into a base countable. Base countables have useful default implementation for `Object.equals(Object)`, `Object.hashCode()`, and `Object.toString()`.
      Specified by:
        `asBase` in interface `IntCountable`
      Specified by:
        `asBase` in interface `IntIndexable`
      Overrides:
        `asBase` in class `IntCountable.Base`
      Returns:
        base indexable